package adles2;

import java.util.HashMap;
import java.util.Map;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;

public class Main {
	
	public static void main(String [] args) {
		
		try {
			// get factory to instantiate the component from ADL 
			Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
			// the has table is used to set up the context
	        Map<String, Object> context = new HashMap<String, Object>();
	        
	        Component composite = (Component) f.newComponent("adles2.Composite", context);
	        System.out.println(":: Composite Component created ...");
	        
	        Fractal.getLifeCycleController(composite).startFc();
			System.out.println(":: Component started ...");
			
			
			SecondComponentInterface sc = ((SecondComponentInterface) composite.getFcInterface("outer-comp-interface"));
			Object n = sc.compute(new Integer(5));
			System.out.println(":: Object coming back of type : "+n.getClass().getName());
			
			System.out.println(":: Computed sc.compute(5)="+n.toString());
//			
//			
//	        Fractal.getLifeCycleController(simpleComponent).stopFc();
//			System.out.println(":: Component stopped ...");
			
			System.exit(0);
			
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		
	}

}
