package completeOneWayTerminating;

import java.util.List;

public class Collector implements CollectorInterface, TerminatorInterface {

	int ntasks = 0;	        // to be communicated by master, actually ...
	int i = 0; 				// the number of results delivered


	@Override
	public void deliver(List<Integer> res) {
		System.err.println(":: deliver ENTERED ");
		java.util.Iterator<Integer> it = res.iterator();
		while(it.hasNext()) {
			System.err.println(":: result time :: "+it.next());
			i++;
		}
		System.err.println(":: deliver terminating ");
	}

	@Override
	public boolean hasTerminated() {
		System.err.println(":: hasTerminated entered ...");
		if(i==ntasks) 
		return true; 
		else
		return false;
	}

	public void setTaskNo(int t) {
		ntasks = t; 
		return;
	}


}
