package compositeComponent;

import org.osoa.sca.annotations.Reference;

public class SecondComponent implements SecondComponentInterface {

	private SimpleComponentInterface c1; 
	
	@Reference
	public void setC1(SimpleComponentInterface x) {
		System.err.println(":: adding SimpleComponent reference in SecondComponent "+x);
		c1 = x; 
	}
	
	public Integer compute(Integer task) {
		System.err.println(":: compute called with simpleServiceComponent="+c1);
		Integer res = c1.doWork(task);
		int i = res.intValue();
		return new Integer(2*i);
	}

}
